Skip to main content
Available in🇮🇳 India
Before you start, see How Cards Recurring Works and AFA Limits and test your integration. You can create an authorisation transaction using the Razorpay APIs or Registration Link.
Handy TipsBank downtime can affect success rates when processing recurring payments via debit cards.

1.1. Using Razorpay APIs

To create an authorisation transaction using the Razorpay APIs, you need to:
  1. Create a Customer.
  2. Create an Order.
  3. Create Authorisation Payment using Razorpay APIs.

1.1.1. Create a Customer

Token Sharing for Partner Auth ModelIf you are a Razorpay Partner, who wants to use this API via Partner Auth, you must ensure the following:
  • Add the basic auth with partner credentials (client_id and client_secret).
  • Add the account_id of the sub-merchant using X-Razorpay-Account in the header. For example, -H “X-Razorpay-Account: acc_KBrJAIEqre5ucn”
Request
Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API. You can create customers with basic information such as email and contact and use them for various Razorpay offerings. The following endpoint creates a customer.
Handy TipsCreate one customer ID per customer, using a unique email or phone number. Reusing or duplicating customers breaks data analysis and stops the Fetch Tokens by Customer ID API from returning the expected tokens.
POST /customers
string
The name of the customer. For example, Gaurav Kumar.
string
The email address of the customer. For example, gaurav.kumar@example.com.
string
The phone number of the customer. For example, 9876543210.
string
The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:
  • 1 (default): If a customer with the same details already exists, throws an error.
  • 0: If a customer with the same details already exists, fetches details of the existing customer.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
string
The unique identifier of the customer. For example cust_1Aa00000000001.
string
The name of the entity. Here, it is customer.
string
The name of the customer. For example, Gaurav Kumar.
string
The email address of the customer. For example, gaurav.kumar@example.com.
string
The phone number of the customer. For example, 9876543210.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
integer
A Unix timestamp, at which the customer was created.
You can create an order once you create a customer for the payment authorisation.

1.1.2. Create an Order

Use the Orders API to create a unique Razorpay order_id that is associated with the authorisation transaction. The following endpoint creates an order. POST /orders
Token Sharing for Partner Auth ModelIf you are a Razorpay Partner, who wants to use this API via Partner Auth, you must ensure the following:
  • Add the basic auth with partner credentials (client_id and client_secret).
  • Add the account_id of the sub-merchant using X-Razorpay-Account in the header. For example, -H “X-Razorpay-Account: acc_KBrJAIEqre5ucn”
Request
integer
required
Amount in currency subunits. For cards, the minimum value is 100, that is, .
string
required
The 3-letter ISO currency code for the payment.
string
required
The unique identifier of the customer. For example, cust_4xbQrmEoA5WJ01.
string
Payment method used to make the authorisation transaction. Here, it is card.
object
Details related to the authorisation such as max amount, frequency and expiry information.
integer
required
The maximum amount that can be auto-debited in a single charge. The minimum value is 100, that is, . Debits above the India AFA limit (₹15,000, or ₹1,00,000 for eligible business categories) need the customer’s Additional Factor of Authentication (AFA) as per RBI guidelines.
integer
required
The Unix timestamp that indicates when the authorisation transaction must expire. The card’s expiry year is considered a default value.
string
required
The frequency at which you can charge your customer. Possible values:
  • weekly
  • monthly
  • yearly
  • as_presented
string
A user-entered unique identifier for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.
object
Key-value pair you can use to store additional information about the entity. Maximum 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
string
A unique identifier of the order created. For example order_1Aa00000000002.
string
The entity that has been created. Here it is order.
integer
Amount in currency subunits. For cards, the minimum value is 100, that is, .
integer
The amount that has been paid.
integer
The amount that is yet to pay.
string
The 3-letter ISO currency code for the payment.
string
A user-entered unique identifier of the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.
string
Payment method used to make the authorisation transaction. Here, it is card.
string
The unique identifier of the customer. For example, cust_4xbQrmEoA5WJ01.
string
The status of the order.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
integer
The Unix timestamp at which the order was created.
You can create a payment against the order_id after you create an order.

1.1.3. Create an Authorisation Payment

Once an order is created, your next step is to create a payment. Use the below endpoint to create a payment with payment method card.
Check if the Card Supports Recurring PaymentsBefore you create the authorisation payment, you can use the IIN API to check whether the customer’s card supports recurring payments. This is an on-demand feature; raise a request with our Support team to get it activated on your account.GET /iins/:iin. Pass the first 6 digits of the customer’s card number as iin. For example, 438628.
Response
  • recurring.available: true: the card supports recurring payments. Create the authorisation payment.
  • recurring.available: false: the card does not support recurring payments. Do not attempt the authorisation payment; ask the customer to use another card or another payment method.
For the full response, other IIN lengths (including 9-digit tokenised IINs) and error responses, see the IIN API reference.
Token Sharing for Partner Auth ModelIf you are a Razorpay Partner, who wants to use this API via Partner Auth, you must ensure the following:
  • Add the basic auth with partner credentials (client_id and client_secret).
  • Add the account_id of the sub-merchant using X-Razorpay-Account in the header. For example, -H “X-Razorpay-Account: acc_KBrJAIEqre5ucn”
Request
POST /payments/create/json
Handy Tips
  • To process recurring transactions, customer card details will need to be secured/tokenised in accordance with the applicable laws. You will be solely responsible for obtaining informed consent from customers for the processing of emandates and such consent shall be explicit and not by way of a forced/default/automatic selection of check box, radio button etc.
  • When the merchant is sharing recurring: true or preferred, it is for tokenising the card as per applicable rules for recurring mandate creation. If such consent is not shared during the payment flow, then Razorpay will not tokenise the card or process the emandate/ recurring transaction.
integer
required
Amount in currency subunits. For cards, the minimum value is 100, that is, .
string
required
The 3-letter ISO currency code for the payment.
string
required
The unique identifier of the order created in Step 1.1.2.: Create an Order.
string
required
The unique identifier of the customer.
boolean
required
Possible values:
  • true: Recurring payment is enabled.
  • false: Recurring payment is not enabled.
Handy TipsThe recurring parameter also supports the value preferred. Use this when you want to support recurring payments and one-time payment in the same flow.
integer
required
Saves the customer’s card details. Possible values:
  • 1: Saves the card details.
  • 0: Does not save the card details.
string
required
The customer’s email address.
string
required
The customer’s contact number.
string
required
The payment method selected by the customer. Here, the value must be card.
object
The attributes associated with a card.
integer
required
Unformatted card number. This field is required if value of method is card. Use one of our test cards to try out the payment flow.
string
required
The name of the cardholder.
integer
required
The expiry month of the card in MM format. For example, 01 for January and 12 for December.
integer
required
Expiry year for card in the YY format. For example, 2030 will be in format 30.
integer
required
CVV printed on the back of the card.
Handy Tips
  • CVV is not required by default for tokenised cards across all networks.
  • CVV is optional for tokenised card payments. Do not pass dummy CVV values.
  • To implement this change, skip passing the cvv parameter entirely, or pass a null or empty value in the CVV field.
  • We recommend removing the CVV field from your checkout UI/UX for tokenised cards.
  • If CVV is still collected for tokenised cards and the customer enters a CVV, pass the entered CVV value to Razorpay.
If the payment request is valid, the response contains the following fields. Refer to the S2S Json V2 integration document for more details.
string
Unique identifier of the payment. Present for all responses.
array
A list of action objects available to you to continue the payment process. Present when the payment requires further processing.
string
An indication of the next step available to you to continue the payment process. Possible values:
  • otp_generate - Use this URL to allow the customer to generate OTP and complete the payment on your webpage.
  • redirect - Use this URL to redirect the customer to submit the OTP on the bank page.
string
URL to be used for the action indicated.
After this step, you can proceed to integrate with the Fetch Token API. Registration Links are an alternate way of creating an authorisation transaction. If you create a registration link, you need not create a customer or an order. When you create a registration link, an invoice is automatically issued to the customer. The customer can use the invoice to make the Authorisation Payment. Know how to create Registration Links using the Dashboard.
Handy TipsYou can use webhooks to get notifications about successful payments against a registration link. Know more about Webhooks.
A registration link must always have the amount (in currency subunits) that the customer will be charged when making the authorisation payment. For cards, the amount must be a minimum of . The following endpoint creates a registration link. POST /subscription_registration/auth_links
object
Details of the customer to whom the registration link is sent.
string
required
Customer’s name.
string
required
Customer’s email address.
string
required
Customer’s contact number.
string
required
In this case, the value is link.
integer
required
The payment amount in the smallest currency sub-unit.
string
required
The 3-letter ISO currency code for the payment.
string
required
A description that appears on the hosted page.
object
Details of the authorisation transaction.
string
required
The authorisation method. Here it is card.
integer
required
The maximum amount that can be auto-debited in a single charge. The minimum value is 100, that is, . Debits above the India AFA limit (₹15,000, or ₹1,00,000 for eligible business categories) need the customer’s Additional Factor of Authentication (AFA) as per RBI guidelines.
integer
The Unix timestamp till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. The card’s expiry year is considered a default value.
string
required
The frequency at which you can charge your customer. Possible values:
  • weekly
  • monthly
  • yearly
  • as_presented
boolean
Indicates if SMS notifications are to be sent by Razorpay. Possible values:
  • true (default): Notifications are sent by Razorpay .
  • false: Notifications are not sent by Razorpay.
boolean
Indicates if email notifications are to be sent by Razorpay. Possible values:
  • true (default): Notifications are sent by Razorpay .
  • false: Notifications are not sent by Razorpay.
integer
The Unix timestamp indicates the expiry of the registration link.
string
A unique identifier entered by you for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.
object
This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
string
The unique identifier of the invoice.
string
The entity that has been created. Here, it is invoice.
string
A user-entered unique identifier of the invoice.
string
Unique number you added for internal reference.
string
The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.
object
Details of the customer.
string
The unique identifier associated with the customer to whom the invoice has been issued.
string
The customer’s name.
string
The customer’s email address.
integer
The customer’s phone number.
string
Details of the customer’s billing address.
string
Details of the customer’s shipping address.
string
The unique identifier of the order associated with the invoice.
string
Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.
string
Unique identifier of a payment made against the invoice.
string
The status of the invoice. Possible values:
  • draft
  • issued
  • partially_paid
  • paid
  • cancelled
  • expired
  • deleted
integer
The Unix timestamp at which the invoice will expire.
integer
The Unix timestamp at which the invoice was issued to the customer.
integer
The Unix timestamp at which the payment was made.
integer
The Unix timestamp at which the invoice was cancelled.
integer
The Unix timestamp at which the invoice expired.
string
The delivery status of the SMS notification for the invoice sent to the customer. Possible values:
  • pending
  • sent
string
The delivery status of the email notification for the invoice sent to the customer. Possible values:
  • pending
  • sent
integer
Timestamp, in Unix format, that indicates the issue date of the invoice.
string
Any terms to be included in the invoice. Maximum of 2048 characters.
boolean
Indicates whether the customer can make a partial payment on the invoice. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
integer
Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is , pass the value as 29995.
integer
Amount paid by the customer against the invoice.
integer
The remaining amount to be paid by the customer for the issued invoice.
string
The currency associated with the invoice.
string
A brief description of the invoice.
object
Any custom notes added to the invoice. Maximum of 2048 characters.
string
The short URL that is generated. This is the link that can be shared with the customer to receive payments.
string
Here, it is invoice.
string
Any comments to be added in the invoice. Maximum of 2048 characters.

1.2.2. Send/Resend Notifications

The following endpoint sends/resends notifications with the short URL to the customer: POST /invoices/:id/notify_by/:medium
string
required
The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001.
string
required
Determines through which medium you want to resend the notification. Possible values:
  • sms
  • email
boolean
Indicates whether the notifications were sent successfully. Possible values:
  • true: The notifications were successfully sent via SMS, email or both.
  • false: The notifications were not sent.
The following endpoint cancels a registration link. POST /invoices/:id/cancel
Handy TipsYou can only cancel registration link in the issued state.
string
required
The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.
string
The unique identifier of the invoice.
string
The entity that has been created. Here, it is invoice.
string
A user-entered unique identifier of the invoice.
string
Unique number you added for internal reference.
string
The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.
object
Details of the customer.
string
The unique identifier associated with the customer to whom the invoice has been issued.
string
The customer’s name.
string
The customer’s email address.
integer
The customer’s phone number.
string
Details of the customer’s billing address.
string
Details of the customer’s shipping address.
string
The unique identifier of the order associated with the invoice.
string
Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.
string
Unique identifier of a payment made against the invoice.
string
The status of the invoice. Possible values:
  • draft
  • issued
  • partially_paid
  • paid
  • cancelled
  • expired
  • deleted
integer
The Unix timestamp at which the invoice will expire.
integer
The Unix timestamp at which the invoice was issued to the customer.
integer
The Unix timestamp at which the payment was made.
integer
The Unix timestamp at which the invoice was cancelled.
integer
The Unix timestamp at which the invoice expired.
string
The delivery status of the SMS notification for the invoice sent to the customer. Possible values:
  • pending
  • sent
string
The delivery status of the email notification for the invoice sent to the customer. Possible values:
  • pending
  • sent
integer
Timestamp, in Unix format, that indicates the issue date of the invoice.
string
Any terms to be included in the invoice. Maximum of 2048 characters.
boolean
Indicates whether the customer can make a partial payment on the invoice. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
integer
Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is , pass the value as 29995.
integer
Amount paid by the customer against the invoice.
integer
The remaining amount to be paid by the customer for the issued invoice.
string
The currency associated with the invoice.
string
A brief description of the invoice.
object
Any custom notes added to the invoice. Maximum of 2048 characters.
string
The short URL that is generated. This is the link that can be shared with the customer to receive payments.
string
Here, it is invoice.
string
Any comments to be added in the invoice. Maximum of 2048 characters.
After this step, you can proceed to integrate with the Fetch Token API.

1.3. Error Scenarios

If the authorisation payment fails, the payment carries an error object with code, description, source, step and reason. Use the reason to decide the next action for the customer. For the Cards Recurring error reasons, see Error Codes.
Last modified on November 19, 2026